<?php
/*************************
  Coppermine Photo Gallery WBB Bridge
  ************************
  Copyright (c) 2006 Cyberspectrum

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  ********************************************
  Comaptible for Coppermine version: 1.4.3
  Author: xtra@bin-i.ch
  Date: 2006-01-27
**********************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

require_once 'bridge/udb_base.inc.php';

class cpg_udb extends core_udb {

	function cpg_udb()
	{
		global $BRIDGE, $boardurl, $boardconfig;
		$this->boardurl = $BRIDGE['full_forum_url'];
		require_once($BRIDGE['relative_path_to_config_file'].'/config.inc.php');
		require_once($BRIDGE['relative_path_to_config_file']."/options.inc.php");
		$this->use_post_based_groups = $BRIDGE['use_post_based_groups'];
		$this->multigroups = 1;

		// Database connection settings
	    $this->db = array(
	    	'name' => $sqldb,
	    	'host' => $sqlhost ? $sqlhost : 'localhost',
	    	'user' => $sqluser,
	    	'password' => $sqlpassword,
	    	'prefix' => 'bb'.$n.'_'
		);
		
		// Board table names

		$this->table = array(
			'users' => 'users',
			'groups' => 'groups',
			'sessions' => 'sessions',
			'usergroups' => 'user2groups'
		);



		// Derived full table names

		$this->usertable = '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['users'];
		$this->groupstable =  '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['groups'];
		$this->sessionstable =  '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['sessions'];
		$this->usergroupstable=  '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['usergroups'];

		// Table field names

		$this->field = array(
			'username' => 'username', // name of 'username' field in users table
			'user_id' => 'userid', // name of 'id' field in users table
			'password' => 'password', // name of 'password' field in users table
			'email' => 'email', // name of 'email' field in users table
			'regdate' => 'regdate', // name of 'registered' field in users table
			'location' => "''", // name of 'location' field in users table
			'website' => 'homepage', // name of 'website' field in users table
			'usertbl_group_id' => "groupid", // name of 'group id' field in users table
			'grouptbl_group_id' => "groupid", // name of 'group id' field in groups table
			'grouptbl_group_name' => "title" // name of 'group name' field in groups table
		);

		

		// Pages to redirect to

		$this->page = array(
			'register' => '/register.php',
			'editusers' => '/memberslist.php',
			'edituserprofile' => "/profile.php?userid=",
		);

		

		// Group ids - admin and guest only.

		$this->admingroups = array(1);

		$this->guestgroup = $this->use_post_based_groups ? 105 : 3;

		

		// Use a special function to collect groups for cpg groups table

		$this->group_overrride = 0;

		

		// Cookie settings - used in following functions only

		// get cookieprefix from vb3.0.x
		$this->cookie_name = "wbb2_";

		// Connect to db
		$this->connect();
	}

	// definition of how to extract id, name, group from a session cookie
	function session_extraction()
	{
		if (isset($_COOKIE[$this->cookie_name . 'cookiehash'])) {
			$session_id = addslashes($_COOKIE[$this->cookie_name . 'cookiehash']);
			$sql = "SELECT u.".$this->field['user_id'].", u.".$this->field['password'].
			" FROM ".$this->usertable." AS u, ".$this->sessionstable." AS s".
			" WHERE s.".$this->field['user_id']."=u.".$this->field['user_id']." AND s.sessionhash='".$session_id."'";
			$result = cpg_db_query($sql, $this->link_id);
			if (mysql_num_rows($result)){
				$row = mysql_fetch_array($result);
				return array($row[$this->field['user_id']], $row[$this->field['password']]);
			} else {
			    return false;
			}
		}
	}

	// Get groups of which user is member
	function get_groups($row)
	{
		$int_pref='`'.$this->db['name'].'`.'.$this->db['prefix'];
		$id=$row['id'];

		$sql="SELECT gc.groupids FROM ".$int_pref."users AS u, ".$int_pref."groupcombinations AS gc WHERE u.groupcombinationid=gc.groupcombinationid AND u.userid='$id'";
		$result = cpg_db_query($sql);
		$groups = mysql_fetch_array($result);
		$groupids = explode(',', $groups['groupids']);
		if($this->use_post_based_groups) {
			for($i=0;$i<count($groupids);$i++) {
				$groupids[$i]+=100;
			}
		}
		return $groupids;
	}

	function cookie_extraction()
	{
		return false;
	}

	// definition of actions required to convert a password from user database form to cookie form
	function udb_hash_db($password)
	{
		return $password; // unused
	}

	function login_page()
	{
		$this->redirect("/index.php");
	}

	function logout_page()
	{
		$this->redirect("/logout.php".USER_ID);
	}
}



// and go !

$cpg_udb = new cpg_udb;

?>
